VirtualBox

source: vbox/trunk/src/VBox/Installer/solaris/vboxdrv.sh@ 9230

Last change on this file since 9230 was 8867, checked in by vboxsync, 16 years ago

Solaris installer: Added desktop entry for launching VirtualBox.

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 2.9 KB
Line 
1#!/bin/sh
2# Sun xVM VirtualBox
3# VirtualBox kernel module control script for Solaris.
4#
5# Copyright (C) 2007-2008 Sun Microsystems, Inc.
6#
7# This file is part of VirtualBox Open Source Edition (OSE), as
8# available from http://www.virtualbox.org. This file is free software;
9# you can redistribute it and/or modify it under the terms of the GNU
10# General Public License (GPL) as published by the Free Software
11# Foundation, in version 2 as it comes in the "COPYING" file of the
12# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
13# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
14#
15# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
16# Clara, CA 95054 USA or visit http://www.sun.com if you need
17# additional information or have any questions.
18#
19
20SILENTUNLOAD=""
21MODNAME="vboxdrv"
22MODDIR32="/platform/i86pc/kernel/drv"
23MODDIR64=$MODDIR32/amd64
24
25abort()
26{
27 echo 1>&2 "$1"
28 exit 1
29}
30
31info()
32{
33 echo 1>&2 "$1"
34}
35
36check_if_installed()
37{
38 cputype=`isainfo -k`
39 modulepath="$MODDIR32/$MODNAME"
40 if test "$cputype" = "amd64"; then
41 modulepath="$MODDIR64/$MODNAME"
42 fi
43 if test -f "$modulepath"; then
44 return 0
45 fi
46 abort "VirtualBox kernel module NOT installed."
47}
48
49module_loaded()
50{
51 if test -f "/etc/name_to_major"; then
52 loadentry=`cat /etc/name_to_major | grep $MODNAME`
53 else
54 loadentry=`/usr/sbin/modinfo | grep $MODNAME`
55 fi
56 if test -z "$loadentry"; then
57 return 1
58 fi
59 return 0
60}
61
62check_root()
63{
64 if test `/usr/xpg4/bin/id -u` -ne 0; then
65 abort "This program must be run with administrator privileges. Aborting"
66 fi
67}
68
69start_module()
70{
71 if module_loaded; then
72 info "VirtualBox kernel module already loaded."
73 else
74 /usr/sbin/add_drv -m'* 0666 root sys' $MODNAME
75 if test ! module_loaded; then
76 abort "## Failed to load VirtualBox kernel module."
77 elif test -c "/devices/pseudo/$MODNAME@0:$MODNAME"; then
78 info "VirtualBox kernel module loaded."
79 else
80 abort "Aborting due to attach failure."
81 fi
82 fi
83}
84
85stop_module()
86{
87 if module_loaded; then
88 /usr/sbin/rem_drv $MODNAME || abort "## Failed to unload VirtualBox kernel module."
89 info "VirtualBox kernel module unloaded."
90 elif test -z "$SILENTUNLOAD"; then
91 info "VirtualBox kernel module not loaded."
92 fi
93}
94
95restart_module()
96{
97 stop_module
98 sync
99 start_module
100 return 0
101}
102
103status_module()
104{
105 if module_loaded; then
106 info "Running."
107 else
108 info "Stopped."
109 fi
110}
111
112check_root
113check_if_installed
114
115if test "$2" = "silentunload"; then
116 SILENTUNLOAD="$2"
117fi
118
119case "$1" in
120start)
121 start_module
122 ;;
123stop)
124 stop_module
125 ;;
126restart)
127 restart_module
128 ;;
129status)
130 status_module
131 ;;
132*)
133 echo "Usage: $0 {start|stop|restart|status}"
134 exit 1
135esac
136
137exit
138
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette